﻿EnableExplicit

;#gDrawing_NO_DLL_IMPORT = 1

XIncludeFile "gDrawing.pbi"

Procedure Draw(image)
    Protected height

    If gStartDrawing( ImageOutput(image) )
        gClear(RGBA($80,$80,$80,$FF))
        gSetPenColor(RGBA(0,0,0,$FF))
        gSetFont("Arial",20,#PB_Font_Bold)
        height = gTextHeight()

        gSetDrawTextFlags(#DrawTextLeftAligned|#DrawTextShowHotkey)
        gDrawFormattedText(0,height* 0,800,height,"&Left aligned text.")
        gSetDrawTextFlags(#DrawTextCentered|#DrawTextShowHotkey)
        gDrawFormattedText(0,height* 1,800,height,"&C&e&n&t&e&r&e&d text.")
        gSetDrawTextFlags(#DrawTextRightAligned|#DrawTextShowHotkey)
        gDrawFormattedText(0,height* 2,800,height,"&Right aligned text.")
        
        gBox(10,100,300,200,RGBA($FF,$FF,$FF,$FF))
        gSetDrawTextFlags(#DrawTextRightAligned|#DrawTextLineCentered|#DrawTextShowHotkey)
        gDrawFormattedText(10,100,300,200,"Right aligned."+Chr(10)+"Lines centered."+Chr(10)+"&Show ampersand: &&")
        
        gBox(10,320,250,height,RGBA($FF,$FF,$FF,$FF))
        gSetDrawTextFlags(#DrawTextEllipsisPathTrimming)
        gDrawFormattedText(10,320,250,height,"http://www.purebasic.com/news/")
        gSetDrawTextFlags(#DrawTextEllipsisCharacterTrimming)
        gDrawRotatedFormattedText(10,420,250,height,"http://www.purebasic.com/news/",20,RGBA($00,$FF,$FF,$FF))
        
        gStopDrawing()
    EndIf
EndProcedure

Define img

If gInit()

    img = CreateImage(#PB_Any,800,600)
    Draw(img)

    OpenWindow(#PB_Any,0,0,800,600,"gDrawing",#PB_Window_SystemMenu|#PB_Window_ScreenCentered)
    ImageGadget(#PB_Any,0,0,800,600,ImageID( img ))
    Repeat : Until WaitWindowEvent()=#PB_Event_CloseWindow

    gEnd()
EndIf
; IDE Options = PureBasic 4.60 (Windows - x86)
; EnableUnicode
; EnableXP
; Executable = example22.exe
; CPU = 5
; DisableDebugger